/*----------------------------------------------------------------------*/
/*	                     SegaXtreme contest 2003						*/
/*----------------------------------------------------------------------*/
#include	"sgl.h"
#include	"sega_sys.h"

void UpdateSpritePosition(void);
void KnucleRun(void);
void KnucleRunBackward(void);
void SonicRun(void);
void SonicRunBackward(void);
void ShowRing(void);
void SonicWarn(void);
void SonicWarnInvert(void);

#define		RBG0RB_CEL_ADR			(VDP2_VRAM_A0            )
#define		RBG0RB_MAP_ADR			(VDP2_VRAM_B0            )
#define		RBG0RB_COL_ADR			(VDP2_COLRAM    + 0x00200)
#define		RBG0RA_CEL_ADR			(RBG0RB_CEL_ADR + 0x06e80)
#define		RBG0RA_MAP_ADR			(RBG0RB_MAP_ADR + 0x02000)
#define		RBG0RA_COL_ADR			(RBG0RB_COL_ADR + 0x00200)
#define		RBG0_KTB_ADR			(VDP2_VRAM_A1            )
#define		RBG0_PRA_ADR			(VDP2_VRAM_A1   + 0x1fe00)
#define		RBG0_PRB_ADR			(RBG0_PRA_ADR   + 0x80   )
#define		BACK_COL_ADR			(VDP2_VRAM_A1   + 0x1fffe)
#define		PAD_NUM			13

static Uint16 pad_asign[] = {
	PER_DGT_KU,
	PER_DGT_KD,
	PER_DGT_KR,
	PER_DGT_KL,
	PER_DGT_TA,
	PER_DGT_TB,
	PER_DGT_TC,
	PER_DGT_ST,
	PER_DGT_TX,
	PER_DGT_TY,
	PER_DGT_TZ,
	PER_DGT_TR,
	PER_DGT_TL,
};


extern TEXTURE tex_spr[];
extern PICTURE pic_spr[];
extern FIXED stat[][XYZS];
extern SPR_ATTR attr[];
extern ANGLE angz[];

int tempo_knu_run, tempo_son_run, tempo_ring, tempo_son_warn;

/*----------------------------------------------------------------------*/
static void set_sprite(PICTURE *pcptr , Uint32 NbPicture)
{
	TEXTURE *txptr;
 
	for(; NbPicture-- > 0; pcptr++){
		txptr = tex_spr + pcptr->texno;
		slDMACopy((void *)pcptr->pcsrc,
			(void *)(SpriteVRAM + ((txptr->CGadr) << 3)),
			(Uint32)((txptr->Hsize * txptr->Vsize * 4) >> (pcptr->cmode)));
	}
}

/*----------------------------------------------------------------------*/
static void disp_sprite(int SpriteNo)
{
	
	slDispSprite((FIXED *)stat[SpriteNo], (SPR_ATTR *)(&attr[SpriteNo].texno), DEGtoANG(0));
	
}

/*----------------------------------------------------------------------*/
void ss_main(void)
{
	Uint16 data;
	PerDigital	*pptr ;
    Sint16	padp ;
	
	int demo_timer;

	slInitSystem(TV_320x224,tex_spr,1);
	init_sound() ;

	set_sprite(pic_spr,53);

	demo_timer = 0;
	tempo_ring = 0;
	tempo_knu_run = 0;
	tempo_son_run = 0;

	while(1) 
	{
		if(!Per_Connect1) return;
		data = Smpc_Peripheral[0].data;
		pptr = Smpc_Peripheral;
		padp = ~pptr->push;

		if((data & pad_asign[5])==0)			/* if B is pressed, restart */
		{
			stat[0][1] = toFIXED(-130.0);
			stat[5][0] = toFIXED(-200.0);
			stat[15][0] = toFIXED( 200.0);
			stat[0][0] = toFIXED(50.0);
			stat[45][1] = toFIXED(130.0);
			stat[46][1] = toFIXED(130.0);
			stat[47][1] = toFIXED(0.0);
			ss_main();
		}		
				
		demo_timer += toFIXED(1.0);
		tempo_ring += toFIXED(1.0);
		tempo_knu_run += toFIXED(1.0);
		tempo_son_run += toFIXED(1.0);
		tempo_son_warn += toFIXED(1.0);

		if(demo_timer <= toFIXED(182.0))
		{
			// the ring is falling
			stat[0][1] += toFIXED(1.0);
			ShowRing();
		}
		
		if(demo_timer <= toFIXED(280.0) & demo_timer >= toFIXED(183.0))
		{
			//knucles appears 
			ShowRing();
			stat[5][0] += toFIXED(1.0);
			KnucleRun();
			
		}

		if(demo_timer <= toFIXED(300.0) & demo_timer >= toFIXED(281.0))
		{
			//knucles stand 1
			ShowRing();
			disp_sprite(4);
		}

		if(demo_timer <= toFIXED(340.0) & demo_timer >= toFIXED(301.0))
		{
			//knucles stand 2
			ShowRing();
			disp_sprite(13);
		}

		if(demo_timer <= toFIXED(380.0) & demo_timer >= toFIXED(341.0))
		{
			//knucles stand 1
			ShowRing();
			disp_sprite(4);
		}

		if(demo_timer <= toFIXED(530.0) & demo_timer >= toFIXED(381.0))
		{
			//knucles grab the ring
			ShowRing();
			stat[5][0] += toFIXED(1.0);
			KnucleRun();
			
			if(demo_timer == toFIXED(510.0))
			{
				RingSound();
			}
		}

		if(demo_timer <= toFIXED(550.0) & demo_timer >= toFIXED(531.0))
		{
			//knucles got the ring and wait 1
			disp_sprite(4);
		}

		if(demo_timer <= toFIXED(590.0) & demo_timer >= toFIXED(551.0))
		{
			//knucles wait 2
			disp_sprite(13);
		}

		if(demo_timer <= toFIXED(610.0) & demo_timer >= toFIXED(591.0))
		{
			//knucles stand 1
			disp_sprite(4);
		}

		if(demo_timer <= toFIXED(730.0) & demo_timer >= toFIXED(611.0))
		{
			//knucles escape with the ring
			stat[5][0] += toFIXED(1.0);
			KnucleRun();
		}

		if(demo_timer <= toFIXED(790.0) & demo_timer >= toFIXED(731.0))
		{
			//knucles is hurt by Sonic
			stat[5][0] -= toFIXED(2.0);
			disp_sprite(14);

			if(demo_timer == toFIXED(734.0))
			{
				BumpSound();
			}

			//Sonic appears
			stat[15][0] -= toFIXED(1.0);
			SonicRun();
		}

		if(demo_timer <= toFIXED(900.0) & demo_timer >= toFIXED(791.0))
		{
			//knucles and Sonic stares at each other
			disp_sprite(4);
			disp_sprite(23);
		}

		if(demo_timer <= toFIXED(930.0) & demo_timer >= toFIXED(901.0))
		{
			//Sonic chase knucles (both run)
			stat[5][0] -= toFIXED(1.0);
			KnucleRunBackward();

			stat[15][0] -= toFIXED(1.0);
			SonicRun();

			//replace the ring at top left
			stat[0][1] = toFIXED(-130);
			stat[0][0] = toFIXED(-130);
		}

		if(demo_timer <= toFIXED(1090.0) & demo_timer >= toFIXED(931.0))
		{
			//Sonic chase knucles (both run)
			stat[5][0] -= toFIXED(1.0);
			KnucleRunBackward();

			stat[15][0] -= toFIXED(1.0);
			SonicRun();

			// the ring is falling
			stat[0][1] += toFIXED(1.0);
			ShowRing();

			if(demo_timer == toFIXED(1089.0))
			{
				HitSound();
			}
		}

		if(demo_timer <= toFIXED(1150.0) & demo_timer >= toFIXED(1091.0))
		{
			//Knucles down
			disp_sprite(32);
			
			//Sonic Warn him
			SonicWarn();
			stat[0][1] = toFIXED(65.0);
			
			ShowRing();
		}

		if(demo_timer <= toFIXED(1230.0) & demo_timer >= toFIXED(1151.0))
		{
			//Knucles down
			disp_sprite(32);

			//Sonic run
			stat[15][0] -= toFIXED(1.0);
			SonicRun();

			ShowRing();

			if(demo_timer == toFIXED(1229.0))
			{
				RingSound();
			}
		}

		if(demo_timer <= toFIXED(1320.0) & demo_timer >= toFIXED(1231.0))
		{
			//Knucles down
			disp_sprite(32);

			//Sonic run
			stat[15][0] -= toFIXED(1.0);
			SonicRun();
		}

		if(demo_timer <= toFIXED(1500.0) & demo_timer >= toFIXED(1321.0))
		{
			//Knucles chase Sonic 
			stat[5][0] -= toFIXED(1.0);
			KnucleRunBackward();
		}

		if(demo_timer <= toFIXED(1600.0) & demo_timer >= toFIXED(1501.0))
		{
			//Show credit
			stat[46][1] -= toFIXED(1.0);
			disp_sprite(46);
			//prepare knucle's position
			stat[5][0] = toFIXED(-200.0);
		}

		if(demo_timer <= toFIXED(1700.0) & demo_timer >= toFIXED(1601.0))
		{
			//Show credit
			disp_sprite(46);
			//knucles appears 
			stat[5][0] += toFIXED(1.0);
			KnucleRun();
		}

		if(demo_timer <= toFIXED(2200.0) & demo_timer >= toFIXED(1701.0))
		{
			//Show credit
			stat[46][1] -= toFIXED(1.0);
			disp_sprite(46);
			stat[45][1] -= toFIXED(1.0);
			disp_sprite(45);
			//knucles run
			stat[5][0] += toFIXED(1.0);
			KnucleRun();
			//sonic follow
			stat[15][0] += toFIXED(1.0);
			SonicRunBackward();
		}

		if(demo_timer <= toFIXED(2400.0) & demo_timer >= toFIXED(2201.0))
		{
			//show sxlogo
			disp_sprite(47);
			slPrint("Visit", slLocate(15,10));
			slPrint("http://www.segaxtreme.com", slLocate(7,17));
			//prepare knucle's position (right side)
			stat[5][0] = toFIXED(200.0);
			//prepare sonic's position (left side)
			stat[15][0] = toFIXED(-200.0);
		}

		if(demo_timer <= toFIXED(2500.0) & demo_timer >= toFIXED(2401.0))
		{
			//show sxlogo
			slPrint("Visit", slLocate(15,10));
			slPrint("http://www.segaxtreme.com", slLocate(7,17));
			disp_sprite(47);
			//knucle run
			stat[5][0] -= toFIXED(1.0);
			KnucleRunBackward();
			//sonic run
			stat[15][0] += toFIXED(1.0);
			SonicRunBackward();
		}

		if(demo_timer <= toFIXED(5000.0) & demo_timer >= toFIXED(2501.0))
		{
			//show sxlogo
			slPrint("Visit", slLocate(15,10));
			slPrint("http://www.segaxtreme.com", slLocate(7,17));
			disp_sprite(47);
			//knucle stand
			disp_sprite(48);
			//sonic warn
			SonicWarnInvert();
		}

		if(demo_timer >= toFIXED(5001.0))
		{
			//play again
			stat[0][1] = toFIXED(-130.0);
			stat[5][0] = toFIXED(-200.0);
			stat[15][0] = toFIXED( 200.0);
			stat[0][0] = toFIXED(50.0);
			stat[45][1] = toFIXED(130.0);
			stat[46][1] = toFIXED(130.0);
			stat[47][1] = toFIXED(0.0);
			ss_main();
		}


		UpdateSpritePosition();
		

//////////////////////////////////////////////////////////

		slSynch();
	} 
}

void UpdateSpritePosition()
{
	//ring position
	stat[1][1] = stat[0][1];	stat[1][0] = stat[0][0];
	stat[2][1] = stat[0][1];	stat[2][0] = stat[0][0];
	stat[3][1] = stat[0][1];	stat[3][0] = stat[0][0];

	//knucles position
	stat[4][0] = stat[5][0];	
	stat[6][0] = stat[5][0];	
	stat[7][0] = stat[5][0];	
	stat[8][0] = stat[5][0];	
	stat[9][0] = stat[5][0];	
	stat[10][0] = stat[5][0];	
	stat[11][0] = stat[5][0];	
	stat[12][0] = stat[5][0];	
	stat[13][0] = stat[5][0];	
	stat[14][0] = stat[5][0];
	
	stat[24][0] = stat[5][0];	
	stat[25][0] = stat[5][0];
	stat[26][0] = stat[5][0];
	stat[27][0] = stat[5][0];
	stat[28][0] = stat[5][0];
	stat[29][0] = stat[5][0];
	stat[30][0] = stat[5][0];
	stat[31][0] = stat[5][0];
	stat[32][0] = stat[5][0];
	stat[48][0] = stat[5][0];


	//sonic position
	stat[16][0] = stat[15][0];	
	stat[17][0] = stat[15][0];	
	stat[18][0] = stat[15][0];	
	stat[19][0] = stat[15][0];	
	stat[20][0] = stat[15][0];	
	stat[21][0] = stat[15][0];	
	stat[22][0] = stat[15][0];	
	stat[23][0] = stat[15][0];	
	
	stat[33][0] = stat[15][0];	
	stat[34][0] = stat[15][0];	
	stat[35][0] = stat[15][0];	
	stat[36][0] = stat[15][0];
	
	stat[37][0] = stat[15][0];	
	stat[38][0] = stat[15][0];	
	stat[39][0] = stat[15][0];	
	stat[40][0] = stat[15][0];	
	stat[41][0] = stat[15][0];	
	stat[42][0] = stat[15][0];	
	stat[43][0] = stat[15][0];	
	stat[44][0] = stat[15][0];
	stat[49][0] = stat[15][0];	
	stat[50][0] = stat[15][0];	
	stat[51][0] = stat[15][0];	
	stat[52][0] = stat[15][0];
}


void KnucleRun()
{
	if(tempo_knu_run <= toFIXED(3.0))
	{
		disp_sprite(5);
	}
	if(tempo_knu_run <= toFIXED(7.0) & tempo_knu_run >= toFIXED(4.0))
	{
		disp_sprite(6);
	}
	if(tempo_knu_run <= toFIXED(11.0) & tempo_knu_run >= toFIXED(8.0))
	{
		disp_sprite(7);
	}
	if(tempo_knu_run <= toFIXED(16.0) & tempo_knu_run >= toFIXED(12.0))
	{
		disp_sprite(8);
	}
	if(tempo_knu_run <= toFIXED(21.0) & tempo_knu_run >= toFIXED(17.0))
	{
		disp_sprite(9);
	}
	if(tempo_knu_run <= toFIXED(25.0) & tempo_knu_run >= toFIXED(22.0))
	{
		disp_sprite(10);
	}
	if(tempo_knu_run <= toFIXED(29.0) & tempo_knu_run >= toFIXED(26.0))
	{
		disp_sprite(11);
	}
	if(tempo_knu_run <= toFIXED(33.0) & tempo_knu_run >= toFIXED(30.0))
	{
		disp_sprite(12);
	}	
	if(tempo_knu_run >= toFIXED(34))
	{
		disp_sprite(12);
		tempo_knu_run = 0;
	}
}

void KnucleRunBackward()
{
	if(tempo_knu_run <= toFIXED(3.0))
	{
		disp_sprite(24);
	}
	if(tempo_knu_run <= toFIXED(7.0) & tempo_knu_run >= toFIXED(4.0))
	{
		disp_sprite(25);
	}
	if(tempo_knu_run <= toFIXED(11.0) & tempo_knu_run >= toFIXED(8.0))
	{
		disp_sprite(26);
	}
	if(tempo_knu_run <= toFIXED(16.0) & tempo_knu_run >= toFIXED(12.0))
	{
		disp_sprite(27);
	}
	if(tempo_knu_run <= toFIXED(21.0) & tempo_knu_run >= toFIXED(17.0))
	{
		disp_sprite(28);
	}
	if(tempo_knu_run <= toFIXED(25.0) & tempo_knu_run >= toFIXED(22.0))
	{
		disp_sprite(29);
	}
	if(tempo_knu_run <= toFIXED(29.0) & tempo_knu_run >= toFIXED(26.0))
	{
		disp_sprite(30);
	}
	if(tempo_knu_run <= toFIXED(33.0) & tempo_knu_run >= toFIXED(30.0))
	{
		disp_sprite(31);
	}	
	if(tempo_knu_run >= toFIXED(34))
	{
		disp_sprite(31);
		tempo_knu_run = 0;
	}
}

void SonicRun()
{
	if(tempo_son_run <= toFIXED(3.0))
	{
		disp_sprite(15);
	}
	if(tempo_son_run <= toFIXED(7.0) & tempo_son_run >= toFIXED(4.0))
	{
		disp_sprite(16);
	}
	if(tempo_son_run <= toFIXED(11.0) & tempo_son_run >= toFIXED(8.0))
	{
		disp_sprite(17);
	}
	if(tempo_son_run <= toFIXED(16.0) & tempo_son_run >= toFIXED(12.0))
	{
		disp_sprite(18);
	}
	if(tempo_son_run <= toFIXED(21.0) & tempo_son_run >= toFIXED(17.0))
	{
		disp_sprite(19);
	}
	if(tempo_son_run <= toFIXED(25.0) & tempo_son_run >= toFIXED(22.0))
	{
		disp_sprite(20);
	}
	if(tempo_son_run <= toFIXED(29.0) & tempo_son_run >= toFIXED(26.0))
	{
		disp_sprite(21);
	}
	if(tempo_son_run <= toFIXED(33.0) & tempo_son_run >= toFIXED(30.0))
	{
		disp_sprite(22);
	}	
	if(tempo_son_run >= toFIXED(34))
	{
		disp_sprite(22);
		tempo_son_run = 0;
	}
}

void SonicRunBackward()
{
	if(tempo_son_run <= toFIXED(3.0))
	{
		disp_sprite(37);
	}
	if(tempo_son_run <= toFIXED(7.0) & tempo_son_run >= toFIXED(4.0))
	{
		disp_sprite(38);
	}
	if(tempo_son_run <= toFIXED(11.0) & tempo_son_run >= toFIXED(8.0))
	{
		disp_sprite(39);
	}
	if(tempo_son_run <= toFIXED(16.0) & tempo_son_run >= toFIXED(12.0))
	{
		disp_sprite(40);
	}
	if(tempo_son_run <= toFIXED(21.0) & tempo_son_run >= toFIXED(17.0))
	{
		disp_sprite(41);
	}
	if(tempo_son_run <= toFIXED(25.0) & tempo_son_run >= toFIXED(22.0))
	{
		disp_sprite(42);
	}
	if(tempo_son_run <= toFIXED(29.0) & tempo_son_run >= toFIXED(26.0))
	{
		disp_sprite(43);
	}
	if(tempo_son_run <= toFIXED(33.0) & tempo_son_run >= toFIXED(30.0))
	{
		disp_sprite(44);
	}	
	if(tempo_son_run >= toFIXED(34))
	{
		disp_sprite(44);
		tempo_son_run = 0;
	}
}

void SonicWarn()
{
	if(tempo_son_warn <= toFIXED(7.0))
	{
		disp_sprite(33);
	}
	if(tempo_son_warn <= toFIXED(13.0) & tempo_son_warn >= toFIXED(8.0))
	{
		disp_sprite(34);
	}
	if(tempo_son_warn <= toFIXED(19.0) & tempo_son_warn >= toFIXED(14.0))
	{
		disp_sprite(35);
	}
	if(tempo_son_warn <= toFIXED(25.0) & tempo_son_warn >= toFIXED(20.0))
	{
		disp_sprite(36);
	}
	if(tempo_son_warn >= toFIXED(26))
	{
		disp_sprite(36);
		tempo_son_warn = 0;
	}
}

void SonicWarnInvert()
{
	if(tempo_son_warn <= toFIXED(7.0))
	{
		disp_sprite(49);
	}
	if(tempo_son_warn <= toFIXED(13.0) & tempo_son_warn >= toFIXED(8.0))
	{
		disp_sprite(50);
	}
	if(tempo_son_warn <= toFIXED(19.0) & tempo_son_warn >= toFIXED(14.0))
	{
		disp_sprite(51);
	}
	if(tempo_son_warn <= toFIXED(25.0) & tempo_son_warn >= toFIXED(20.0))
	{
		disp_sprite(52);
	}
	if(tempo_son_warn >= toFIXED(26))
	{
		disp_sprite(52);
		tempo_son_warn = 0;
	}
}

void ShowRing()
{
	if(tempo_ring <= toFIXED(7.0))
	{
		disp_sprite(0);
	}
	if(tempo_ring <= toFIXED(13.0) & tempo_ring >= toFIXED(8.0))
	{
		disp_sprite(1);
	}
	if(tempo_ring <= toFIXED(19.0) & tempo_ring >= toFIXED(14.0))
	{
		disp_sprite(2);
	}
	if(tempo_ring <= toFIXED(25.0) & tempo_ring >= toFIXED(20.0))
	{
		disp_sprite(3);
	}
	if(tempo_ring >= toFIXED(26))
	{
		disp_sprite(3);
		tempo_ring = 0;
	}
}